<template>
  <InventoryDialog />
  <StockTakingDialog />
  <ReplenishmentDialog />
  <v-container fluid class="h-100">
    <v-card rounded="xl">
      <template #title>
        <v-select
          hide-details
          rounded="lg"
          class="mt-2"
          variant="outlined"
          label="Branch"
          :rules="[requiredRule]"
          :items="store.availableInventory"
          :item-title="'branch.name'"
          return-object
          @update:model-value="store.handleInventorySelected"
          placeholder="Select branch"
        >
        </v-select>
      </template>

      <template #actions>
        <div class="mx-3">
          {{ `Total Value : ${store.selectedInventory?.totalValue ?? 0} ฿ ` }}
        </div>
        <v-row class="justify-end pa-5">
          <v-menu>
            <template #activator="{ props }">
              <v-btn prepend-icon="mdi-clock" v-bind="props">History</v-btn>
            </template>
            <v-list style="cursor: pointer">
              <v-list-item>
                <router-link class="listItemHover" to="/stock-taking-history" target="_blank"
                  >Stock-taking</router-link
                >
              </v-list-item>
              <v-list-item class="listItemHover">
                <router-link class="listItemHover" to="/replenishment-history" target="_blank"
                  >Replenishment</router-link
                >
              </v-list-item>
            </v-list>
          </v-menu>
          <v-menu>
            <template #activator="{ props }">
              <v-btn prepend-icon="mdi-open-in-app" v-bind="props">Quick Actions </v-btn>
            </template>
            <v-list style="cursor: pointer">
              <v-list-item @click="storeStock.openDialog()" class="listItemHover"
                >Stock-taking</v-list-item
              >
              <v-list-item class="listItemHover" @click="storeRep.openDialog()"
                >Replenishment</v-list-item
              >
            </v-list>
          </v-menu>
        </v-row>
      </template>
    </v-card>
    <v-card rounded="lg" class="my-5" height="420">
      <InventoryTable />
    </v-card>
    <v-card rounded="lg">
      <template #actions>
        <h5 class="text-grey">
          <v-icon icon="mdi-alert" class="mr-1 ml-1"> </v-icon>
          Be cautious to take any action !
        </h5>
        <v-row class="justify-end pa-3">
          <v-btn prepend-icon="mdi-warehouse" variant="flat" @click="store.openDialog()">
            New Inventory
          </v-btn>
          <v-btn prepend-icon="mdi-close-box" variant="outlined" color="error">
            Dismantle Inventory
          </v-btn>
        </v-row>
      </template>
    </v-card>
  </v-container>
</template>

<script setup lang="ts">
import InventoryDialog from '../components/InventoryDialog.vue'
import InventoryTable from '../components/InventoryTable.vue'
import { useInventoryStore } from '../store/inventory'
import { onMounted } from 'vue'
import StockTakingDialog from '../components/StockTakingDialog.vue'
import ReplenishmentDialog from '../components/ReplenishmentDialog.vue'
import { useStockTakingStore } from '../store/stockTaking'
import { requiredRule } from '@/utils/constants'
import { useReplenishmentStore } from '../store/replenishment'
const store = useInventoryStore()
const storeStock = useStockTakingStore()
const storeRep = useReplenishmentStore()

onMounted(() => {
  store.fetchAll()
})
</script>

<style scoped>
.listItemHover:hover {
  color: gray;
}

a {
  color: black;
}
</style>
